Bug 1350522 - S3 object versioning fails when applied on a non-master zone
Summary: S3 object versioning fails when applied on a non-master zone
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Ceph Storage
Classification: Red Hat
Component: RGW
Version: 2.0
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: rc
: 2.1
Assignee: Yehuda Sadeh
QA Contact: shilpa
Bara Ancincova
URL:
Whiteboard:
Depends On:
Blocks: 1322504 1383917
TreeView+ depends on / blocked
 
Reported: 2016-06-27 16:12 UTC by shilpa
Modified: 2017-07-30 15:41 UTC (History)
12 users (show)

Fixed In Version: RHEL: ceph-10.2.3-7.el7cp Ubuntu: ceph_10.2.3-7redhat1xenial
Doc Type: Bug Fix
Doc Text:
.S3 versioning can now be set on buckets when accessing a non-master zone Previously, it was not possible to set Amazon Simple Storage Service (S3) object versioning on buckets when accessing any zone other than the metadata master zone. The underlying source code has been modified, and S3 versioning can now be set on buckets when accessing a non-master zone as expected.
Clone Of:
Environment:
Last Closed: 2016-11-22 19:27:51 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Ceph Project Bug Tracker 16494 None None None 2016-06-27 16:12:39 UTC
Red Hat Product Errata RHSA-2016:2815 normal SHIPPED_LIVE Moderate: Red Hat Ceph Storage security, bug fix, and enhancement update 2017-03-22 02:06:33 UTC

Description shilpa 2016-06-27 16:12:39 UTC
Description of problem:
Bucket syncs to the master but versioning fails

Version-Release number of selected component (if applicable):
ceph-radosgw-10.2.2-5.el7cp.x86_64

How reproducible:
Always


From non-master zone:

2016-06-27 12:07:27.111065 7f17c8ff9700 20 sending request to http://magna115:8080/test-bucket/?versioning&rgwx-uid=testuser&rgwx-zonegroup=540c9b3f-5eb7-4a67-a581-54bc704ce827
2016-06-27 12:07:27.115883 7f17c8ff9700 10 receive_http_header
2016-06-27 12:07:27.115891 7f17c8ff9700 10 received header:HTTP/1.1 403 Forbidden
2016-06-27 12:07:27.115893 7f17c8ff9700 10 receive_http_header
2016-06-27 12:07:27.115894 7f17c8ff9700 10 received header:x-amz-request-id: tx000000000000000003195-00577116ff-110a-us-1
2016-06-27 12:07:27.115899 7f17c8ff9700 10 receive_http_header
2016-06-27 12:07:27.115914 7f17c8ff9700 10 received header:
2016-06-27 12:07:27.116007 7f17c8ff9700 20 executeforward_request_to_master returned ret=-13
2016-06-27 12:07:27.116015 7f17c8ff9700 2 req 7824:0.005259:s3:PUT /test-bucket/:set_bucket_versioning:completing
2016-06-27 12:07:27.116083 7f17c8ff9700 2 req 7824:0.005327:s3:PUT /test-bucket/:set_bucket_versioning:op status=-13
2016-06-27 12:07:27.116088 7f17c8ff9700 2 req 7824:0.005333:s3:PUT /test-bucket/:set_bucket_versioning:http status=403
2016-06-27 12:07:27.116091 7f17c8ff9700 1 ====== req done req=0x7f17c8ff3710 op status=-13 http_status=403 ======
2016-06-27 12:07:27.116102 7f17c8ff9700 20 process_request() returned -13

Logs from master zone:

/version-bucket/?versioning
2016-06-27 15:05:20.888992 7f034b7ee700 15 calculated digest=pWu4iwlC93IS0qxEbjJG8gMx3UM=
2016-06-27 15:05:20.888994 7f034b7ee700 15 auth_sign=MWGfx53Rnh2qtskf+ee2zLqPZFQ=
2016-06-27 15:05:20.888994 7f034b7ee700 15 compare=-35
2016-06-27 15:05:20.888996 7f034b7ee700 10 failed to authorize request
2016-06-27 15:05:20.888998 7f034b7ee700 20 handler->ERRORHANDLER: err_no=-2027 new_err_no=-2027
2016-06-27 15:05:20.889051 7f034b7ee700 2 req 488:0.000163:s3:PUT /version-bucket/:set_bucket_versioning:op status=0
2016-06-27 15:05:20.889057 7f034b7ee700 2 req 488:0.000169:s3:PUT /version-bucket/:set_bucket_versioning:http status=403
2016-06-27 15:05:20.889062 7f034b7ee700 1 ====== req done req=0x7f034b7e8710 op status=0 http_status=403 ======
2016-06-27 15:05:20.889069 7f034b7ee700 20 process_request() returned -2027

Bucket gets created:
2 req 487:0.113324:s3:PUT /version-bucket/:create_bucket:http status=200
2016-06-27 15:05:20.759948 7f034bfef700 1 ====== req done req=0x7f034bfe9710 op status=0 http_status=200 ======

Comment 2 Christina Meno 2016-06-27 17:12:13 UTC
Yehuda,

This sounds like something I could live without. What do you think?

Comment 3 Yehuda Sadeh 2016-06-27 17:28:09 UTC
We should have it fixed, but not sure that it is a 2.0 blocker.

Comment 4 Ken Dreyer (Red Hat) 2016-06-28 16:35:32 UTC
Document as known issue:

In RHCS 2.0 we can only version in the master zone.

Comment 6 Yehuda Sadeh 2016-06-30 16:49:40 UTC
That's not quite right. Object versioning cannot be set on buckets when accessing any zone other than the metadata master.

Comment 10 Matt Benjamin (redhat) 2016-10-03 18:07:20 UTC
Will backport.

Comment 17 shilpa 2016-10-27 14:30:08 UTC
Verified on ceph-radosgw-10.2.3-10.el7cp.x86_64

Comment 21 errata-xmlrpc 2016-11-22 19:27:51 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-2815.html


Note You need to log in before you can comment on or make changes to this bug.